<?php
defined('C5_EXECUTE') or die('Access Denied.');

use JtFResources\SystemBase;

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

?>
<fieldset style="margin-top:20px;">
    <?php
    $unique_id = SystemBase::id_s('form_completion_list');
    $page_picker = $app->make('helper/form/page_selector');
    ?>
    <div id="<?php echo $unique_id; ?>" class="form-group">
        <table class="table table-striped table-condensed">
            <thead>
            <tr>
                <th>
                    <?php
                    echo t('Page');
                    ?>
                </th>
                <th>
                    <?php
                    echo t('Form Name');
                    ?>
                </th>
                <th>

                </th>
            </tr>
            </thead>

            <tbody>
            <?php
            if (empty($forms_to_list)) {
                $forms_to_list = [
                    0 => [
                        'cid'       => 0,
                        'form_name' => 'form_reform',
                    ],
                ];
            }

            foreach ($forms_to_list as $ix => $form_info) {
                ?>
                <tr class="form_list_row">
                    <td>
                        <?php
                        /*
                         * ToDo - page picker
                         */
                        echo $page_picker->selectPage('forms_to_list[' . $ix . '][cid]', $form_info['cid'] ?? 0);
                        ?>
                    </td>
                    <td>
                        <?php
                        /*
                         * IMPORTANT - Input must be a handle - form names are handles.
                         */
                        echo $form->handle('forms_to_list[' . $ix . '][form_name]', $form_info['form_name'] ?? 'form_reform', ['placeholder' => t('Form name')]);
                        ?>
                    </td>
                    <td>
                        <a href="#remove_form" class="remove_form btn btn-danger btn-sm"
                           title="<?php t('Remove'); ?>">
                            <i class="fa fas fa-trash"></i>
                        </a>
                        <a href="#add_form" class="add_form btn btn-success btn-sm"
                           title="<?php t('Add'); ?>">
                            <i class="fa fas fa-plus"></i>
                        </a>
                        <a href="#sort" class="sort_forms btn btn-secondary btn-sm"
                           title="<?php t('Sort'); ?>"
                           style="cursor: move;cursor: grab;cursor: -moz-grab;cursor: -webkit-grab;"
                        >
                            <i class="fa fas fa-arrows-v fa-arrows-alt-v"></i>
                        </a>
                    </td>
                </tr>
                <?php
            }
            ?>
            </tbody>
        </table>

        <script type="text/javascript">
            (function ($) {
                    $(document).ready(function () {
                        var choose_text = '<?php echo t("Choose Page")?>';
                        var form_list_container = $('#<?php echo $unique_id;?>');
                        var reindex = function () {
                            form_list_container.find('.form_list_row').each(function (ix, el) {
                                var index = ix;
                                var this_form_list_row = $(this);
                                this_form_list_row.find('input,select').each(function () {
                                    var this_input = $(this);

                                    var old_name = this_input.attr('name');
                                    var new_name = old_name.replace(/\[[0-9]+\]/, '[' + ix + ']');
                                    this_input.attr('name', new_name);

                                    var old_id = this_input.attr('id');
                                    if (old_id) {
                                        var new_id = old_id.replace(/\[[0-9]+\]/, '[' + ix + ']');
                                        this_input.attr('id', new_id);
                                    }
                                });
                            });
                        };

                        /*
                         * Separate variants for v9 and v8
                         */
                        var rebuild_v9_page_sel = function (page_sel_widget) {
                            page_sel_widget.find('input').val('');
                            var input_name = page_sel_widget.find('input').attr('name');

                            var old_data_id = page_sel_widget.attr('data-concrete-page-input');
                            var new_data_id = old_data_id;
                            var bug_catch = 0;
                            while ($('div[data-concrete-page-input="' + new_data_id + '"]').length > 0 && bug_catch < 1000) {
                                bug_catch++;
                                new_data_id = old_data_id + '' + bug_catch.toString();
                            }
                            page_sel_widget.attr('data-concrete-page-input', new_data_id);
                            page_sel_widget.html(
                                ' <concrete-page-input :page-id="0" ' +
                                'input-name="' + input_name + '" ' +
                                'choose-text="' + choose_text + '" ' +
                                ':include-system-pages="0" :ask-include-system-pages="0">' +
                                '</concrete-page-input>'
                            );
                            Concrete.Vue.activateContext('cms', function (Vue, config) {
                                new Vue({
                                    el: 'div[data-concrete-page-input="' + new_data_id + '"]',
                                    components: config.components
                                })
                            });
                        }

                        var rebuild_v8_page_sel = function (page_sel_widget) {
                            page_sel_widget.find('input').val('');
                            var input_name = page_sel_widget.find('input').attr('name');

                            var old_data_id = page_sel_widget.attr('data-page-selector');
                            var new_data_id = old_data_id;
                            var bug_catch = 0;
                            while ($('div[data-page-selector="' + new_data_id + '"]').length > 0 && bug_catch < 1000) {
                                bug_catch++;
                                new_data_id = old_data_id + '' + bug_catch.toString();
                            }
                            page_sel_widget.attr('data-page-selector', new_data_id);
                            page_sel_widget.empty();
                            page_sel_widget.concretePageSelector({
                                inputName: input_name,
                                cID: null
                            });
                        }

                        form_list_container.on('click', '.remove_form', function (ev) {
                            ev.preventDefault();
                            ev.stopPropagation();
                            if (form_list_container.find('.form_list_row').length < 2) {
                                $(this).closest('.form_list_row').find('input[type="text"]').val('');
                                return;
                            }
                            $(this).closest('.form_list_row').remove();
                            reindex();
                        });
                        form_list_container.on('click', '.add_form', function (ev) {
                            ev.preventDefault();
                            ev.stopPropagation();
                            var this_form_list_row = $(this).closest('.form_list_row');
                            var new_form_list_row = this_form_list_row.clone();

                            /*
                             * Assume v9, then check for v8.
                             */
                            var v9page_sel_widget = new_form_list_row.find('[data-concrete-page-input]');
                            if (!v9page_sel_widget || v9page_sel_widget.length < 1) {
                                var v8page_sel_widget = new_form_list_row.find('[data-page-selector]');
                            }

                            /*
                             * Make the row which will contain the page selector
                             * reindex the input names
                             */
                            this_form_list_row.after(new_form_list_row);
                            reindex();

                            /*
                             * Do this after the rebuild so all indexes are already adjusted.
                             * All we need to do is the actual rebuild of the page selector widget
                             * for the current core version.
                             */
                            if (v9page_sel_widget && v9page_sel_widget.length > 0) {
                                rebuild_v9_page_sel(v9page_sel_widget);
                            } else if (v8page_sel_widget && v8page_sel_widget.length > 0) {
                                rebuild_v8_page_sel(v8page_sel_widget);
                            }
                        });

                        if ($.fn.sortable && typeof $.fn.sortable === 'function') {
                            form_list_container.sortable({
                                axis: 'y',
                                classes: {'form_list_row': 'selected'},
                                containment: 'parent',
                                cursor: 'grabbing',
                                handle: '.sort_forms',
                                items: '.form_list_row',
                                scroll: true,
                                helper: function (ev, ui) {
                                    ui.width(ui.width());
                                    ui.find('td').each(function () {
                                        $(this).width($(this).width());
                                    })
                                    return ui;
                                },
                                stop: function (ev, ui) {
                                    form_list_container.find('.form_list_row').removeAttr('style');
                                    reindex();
                                    return ui;
                                }
                            });
                        }
                    });
                }
            )
            (jQuery);
        </script>
        <?php

        ?>
    </div>

</fieldset>