<?php

use JtF\FormReform\Utility\TimeInterval;
use JtF\FormReform\FormState\InputPersistence;

defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

?>

<fieldset style="margin-top:20px;">
    <div class="form-group">
        <?php
        $sources_selected = $controller->get('persistence_sources');
        if (!is_array($sources_selected)) {
            $sources_selected = preg_split("/[^0-9a-z]+/i", $sources_selected);
        }

        echo $form->label('persistence_sources', t('Submitted form storage sources (leave empty for all)'));

        $persistence_manager = new InputPersistence();
        foreach ($persistence_manager->listSupportingSaveHandlerChoices() as $k => $v) {
            ?>
            <div class="form-check">
                <?php
                echo $form->checkbox('persistence_sources[]',
                                     $k,
                                     (bool)(!empty($sources_selected) && !empty($k) && in_array($k, $sources_selected)),
                                     ['class' => 'form-check-input']
                );
                echo ' ';
                echo $form->label('persistence_sources[]', t('From %s%s%s handler', '<b>', $v, '</b>'),
                                  ['class' => 'form-check-label']);
                ?>
            </div>
            <?php
        }
        ?>
    </div>
</fieldset>
<fieldset>
    <div class="row">
        <div class="col-5 col-sm-5">
            <div class="form-group">
                <?php
                $more_recent_than = $controller->get('more_recent_than');
                $more_recent_than_u = $controller->get('more_recent_than_u');
                if (empty($more_recent_than)) {
                    $more_recent_than = 0;
                    $more_recent_than_u = '1';
                }

                echo $form->label('more_recent_than', t('More recent than (optional)'));
                ?>
                <div class="form-inline">
                    <div class="input-group">
                        <?php
                        echo $form->number('more_recent_than', $more_recent_than, [
                            'min' => 0,
                            'max' => 10000,
                        ]);
                        $ti = new TimeInterval();
                        echo $form->select('more_recent_than_u',
                                           $ti->moreRecentThanUnits(),
                                           $more_recent_than_u ?? '1',
                                           [
                                               'class' => "input-group-addon input-group-text",
                                           ]
                        );
                        ?>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-7 col-sm-7">
            <div class="alert alert-info">
                <p>
                    <?php
                    echo t('Specify a time window within which a form submission must have been made. Take care to align time windows with update settings in form save handlers.');
                    ?>
                </p>
            </div>
        </div>
    </div>
</fieldset>