<?php

namespace Concrete\Package\JlFormReformDisplay\Block\JlFormReformListResults;

defined('C5_EXECUTE') or die('Access Denied.');

use JtF\FormReformDisplay\DisplayBlockController;
use JtF\FormReformDisplay\Reports\ListMakerDefault;

/*
 * John Liddiard (aka JohntheFish) www.c5magic.co.uk
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

class Controller extends DisplayBlockController
{

    protected $btTable = 'btJlFormReformListResults';

    protected $number_results;
    protected $paginate;

    public function getBlockTypeName()
    {
        return t('List Results');
    }

    public function getBlockTypeDescription()
    {
        return t('List form results from the Form Reform default store.');
    }


    public function on_before_render()
    {

        parent::on_before_render();
        $this->set('metadata_columns', ListMakerDefault::metadata_columns()); // not user specific

        if (!empty($this->form_name)) {
            if(!empty($this->json_filter_configuration)){
                $this->filter_configuration['json_filter'] = $this->json_filter_configuration;
            }
            $lister = $this->app->make(ListMakerDefault::class, [
                'form_name'            => $this->getFormNameToList(),
                'filter_configuration' => $this->filter_configuration ?? null,
                'number_results'       => $this->number_results ?? null,
                'order_by'             => $this->order_by ?? null,
                'paginate'             => $this->paginate ?? false,
            ]);
            $results = $lister->get_paginated_listing();
            $this->set('results', $results);
            if ($lister->has_pagination()) {
                $this->set('pagination', $lister->get_pagination());
            }
        }

    }


    public function save($args)
    {
        if (empty($args['paginate'])) {
            $args['paginate'] = 0;
        }
        parent::save($args);
    }
}
