<?php
defined('C5_EXECUTE') or die('Access Denied.');

use Concrete\Core\User\User;
use Concrete\Core\Page\Page;
use Illuminate\Support\Arr;
use Concrete\Core\View\View;

/*
 * John Liddiard (aka JohntheFish) www.c5magic.co.uk
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

$rows_output = 0;
if (!empty($results)) {
    ?>
    <table class="table table-striped table--stripes form-reform-display-table">
        <?php
        /*
         * We use some common elements to implement the display of each item. For custom templates,
         * you may want to either create your own elements or to code the display of a result inline.
         *
         * The element here is output once for a table heading
         */
        View::element('view/result_table_head',
                      [
                          'controller' => $controller,
                      ],
                      'jl_form_reform_display');
        ?>
        <tbody>
        <?php
        foreach ($results as $result) {
            $form_data = $result->getFormData();
            if (!empty($show_data) || !empty($all_data)) {
                /*
                 * We use some common elements to implement the display of each item. For custom templates,
                 * you may want to either create your own elements or to code the display of a result inline.
                 *
                 * The element here is output once for each result in our list, so once for each table row.
                 */
                View::element('view/result_table_row',
                              [
                                  'controller' => $controller,
                                  'form_data'  => $form_data,
                                  'result'     => $result,
                                  'result_id'  => $result->getId(),
                              ],
                              'jl_form_reform_display');
                $rows_output++;
            }
        }
        ?>
        </tbody>
    </table>
    <?php

    if (!empty($paginate) && !empty($pagination) && !empty($number_results)) {
        echo $pagination;
    }
}


/*
 * All testing needed to display a no result message or an edit mode
 * marker is provided in the element. Just tack this on the end.
 * The controlling flag is $rows_output.
 */
View::element('view/no_result_check',
              [
                  'controller'        => $controller,
                  'rows_output'       => $rows_output,
                  'no_result_message' => $no_result_message,
              ],
              'jl_form_reform_display');


