<?php
defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */
extract($controller->getSets());
$stores = [
    'session' => t("User's Session store"),
    'cookie'  => t("User's Cookie store"),
    'file'    => t("File, CSV or other 'Save to file'"),
];
if (class_exists('JtF\FormReform\Store\FormUserAttributeStore')) {
    $ta_attrs = JtF\FormReform\Store\FormUserAttributeStore::listTextareaAttributes();
    if (!empty($ta_attrs)) {
        $stores['user_attr'] = t("User Text Area attribute store");
    }
}
if (class_exists('JtF\FormReform\Store\FormPageAttributeStore')) {
    $ta_attrs2 = JtF\FormReform\Store\FormPageAttributeStore::listTextareaAttributes();
    if (!empty($ta_attrs2)) {
        $stores['page_attr'] = t("Page Text Area attribute store");
    }
}

?>
    <fieldset style="margin-top:20px;">
        <div id="store_select" class="form-group">
            <?php
            if (empty($store)) {
                $store = 'cookie';
            }
            echo $form->label('store', t('Retrieve form from store'));
            echo $form->select('store', $stores, $store);
            ?>
        </div>
        <div id="file_select" class="form-group">
            <?php
            echo $form->label('file_select', t('Select file'));
            $fileSelector = $app->make('helper/concrete/file_manager');
            echo $fileSelector->file('fID', 'fID', t('Select a file'), $fID ?? null,
                                     [
                                         'filters' => [
                                             [
                                                 'field'     => 'extension',
                                                 'extension' => ['.xml', '.json', '.txt', 'xml', 'json', 'txt','csv'],
                                             ],
                                         ],
                                     ]
            );
            ?>
        </div>
        <script type="text/javascript">
            (function ($) {
                $(document).ready(function () {
                    var store_select = $('#store_select select');
                    var file_select = $('#file_select');
                    store_select.on('change', function (ev, el) {
                        file_select.toggle($(this).val() === 'file');
                    }).trigger('change');
                });
            })(jQuery);
        </script>
        <?php
        if (!empty($stores['user_attr'])) {
            ?>
            <div id="attr_handle_select" class="form-group">
                <?php
                echo $form->label('attr_handle', t('User attribute name'));
                echo $form->select('attr_handle', $ta_attrs, $attr_handle ?? null);
                ?>
            </div>
            <script type="text/javascript">
                (function ($) {
                    $(document).ready(function () {
                        var store_select = $('#store_select select');
                        var attr_handle_select = $('#attr_handle_select');
                        store_select.on('change', function (ev, el) {
                            attr_handle_select.toggle($(this).val() === 'user_attr');
                        }).trigger('change');
                    });
                })(jQuery);
            </script>
            <?php
        }
        if (!empty($stores['page_attr'])) {
            ?>
            <div id="page_attr_handle_select" class="form-group">
                <?php
                echo $form->label('page_attr_handle', t('Page attribute name'));
                echo $form->select('page_attr_handle', $ta_attrs2, $attr_handle ?? null);
                ?>
            </div>
            <script type="text/javascript">
                (function ($) {
                    $(document).ready(function () {
                        var store_select = $('#store_select select');
                        var attr_handle_select = $('#page_attr_handle_select');
                        store_select.on('change', function (ev, el) {
                            attr_handle_select.toggle($(this).val() === 'page_attr');
                        }).trigger('change');
                    });
                })(jQuery);
            </script>
            <?php
        }
        ?>
        <div class="form-group">
            <?php
            echo $form->label('form_name', t('Form Name'));
            echo $form->text('form_name', $controller->getFormNameToList(), ['maxlength' => 255, 'placeholder' => $controller->getDefaultFormName()]);
            ?>
        </div>
    </fieldset>
<?php
