<?php

use JtF\FormReformDisplay\DisplayItemFormatter;

defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */
extract($controller->getSets());

/*
 * These can all be overridden by passing in a string via
 * the View::element param array or setting in the controller
 */

if (empty($item_class)) {
    $item_class = 'form-data-result-item';
}
if (empty($label_class)) {
    $label_class = 'form-data-result-item-label';
}
if (empty($item_content_class)) {
    $item_content_class = 'form-data-result-item-value';
}
if (empty($result_class)) {
    $result_class = 'form-reform-display-list-results-as-content';
}

if (empty($date_format)) {
    $date_format = 'Y-m-d H:i:s';
}

?>
<div class="<?php echo $result_class; ?>"<?php echo $controller->id_attr($result_id??null);?>>
    <?php
    if (!empty($show_data)) {
        /*
         * Go through the columns configured in the 'Data' tab
         * in the sorted order
         */

        foreach ($show_data as $k => $v) {
            unset($data_item);
            if ($k === '__proforma__jtf__') {
                continue;
            }
            if (!empty($show_data_label[$k])) {
                $data_label = $show_data_label[$k];
            } else {
                $data_label = '';
            }

            $display_formatter = new DisplayItemFormatter($k, $result, $form_data, $date_format);

            if (array_key_exists($k, $metadata_columns)) {
                $row_type = 'form-metadata-item';
                $data_item = $display_formatter->formatMetadataItem();
            } else {
                /*
                  * A form data column
                  */
                $format_hint = $show_html[$k] ?? false;
                $row_type = 'form-field-value-item';
                $data_item = $display_formatter->formatDataItem($format_hint, $format_helpers ?? null);
            }
            ?>
            <span class="<?php echo $row_type . ' ' . $item_class . ' ' . $item_class . '-' . $k; ?>">
                <?php
                if (!empty($data_label)) {
                    ?>
                    <span class="<?php echo $label_class; ?>">
                        <?php
                        echo h($data_label);
                        ?>
                    </span>
                    <?php
                }
                ?>
                <span class="<?php echo $item_content_class; ?>">
                    <?php
                    echo $data_item;
                    ?>
                </span>
            </span>
            <?php
        }
    }

    /*
     * May also be configured to show any leftovers
     */
    if (!empty($all_data) && !empty($form_data)) {
        $other_data = [];
        foreach ($form_data as $k => $v) {
            if (!empty($show_data) && array_key_exists($k, $show_data)) {
                continue;
            }
            $data_item = $form_data[$k];
            $data_label = $k;
            $other_data[$data_label] = $data_item;
        }

        /*
         * We don't want too much formatting here. It needs to include enough info identify what to specifically
         * select.
         */
        if (!empty($other_data)) {
            ?>
            <div class="form-field-value-item form-remaining-data">
                <?php
                if (is_scalar($other_data)) {
                    echo h($other_data);
                } else {
                    echo h(json_encode($other_data, JSON_UNESCAPED_SLASHES + JSON_UNESCAPED_UNICODE));
                }
                ?>
            </div>
            <?php
        }
    }
    ?>
</div>
